# include "QIPControl.h"

// create a static instance so that it registers itself with the view factory
CIPControlCreator __gCIPControlCreator;

CIPControl::CIPControl(const CRect& size, int32_t tag, UTF8StringPtr txt, CBitmap* background, const int32_t style)
	: CTextEdit(size, this, tag, txt, background, style)
{
}

CIPControl::CIPControl(const CTextEdit& textEdit)
	: CTextEdit(textEdit)
{
}

void CIPControl::valueChanged()
{
	std::string value = getText();
	ipaddr.fromString(value);
	ipaddr.toString(value);
	setText(value.c_str());
}


// Note you don't need to apply attributes here as the apply method will be called with this new view
CView* CIPControlCreator::create(const UIAttributes& attributes, const IUIDescription* description) const
{
	return new  CIPControl(CRect(0, 0, 100, 20), -1, DEFAULT_IP);
}


// apply custom attributes to your view
bool CIPControlCreator::apply(CView* view, const UIAttributes& attributes, const IUIDescription* description) const
{
	CIPControl* ipc = dynamic_cast<CIPControl*> (view);
	if (ipc == nullptr)
		return false;

//	const std::string* attr = attributes.getAttributeValue("my-custom-attribute");
//	if (attr)
//	{
//		int32_t value = (int32_t)strtol(attr->c_str(), 0, 10);
//		ipc->setCustomAttribute(value);
//	}

	return true;
}


// return the string value of the custom attributes of the view
bool CIPControlCreator::getAttributeValue(CView* view, const std::string& attributeName, std::string& stringValue, const IUIDescription* desc) const
{
	CIPControl* ipc = dynamic_cast<CIPControl*> (view);
	if (ipc == 0)
		return false;
	if (attributeName == "my-custom-attribute")
	{
		std::stringstream stream;
		//			stream << (int32_t)ipc->getCustomAttribute();
		//			stringValue = stream.str();
		return true;
	}
	return false;
}
