#pragma once

#include "vstgui/vstgui.h"
#include "vstgui/uidescription/uiviewfactory.h"
#include "base/source/fstring.h"
#include "pluginterfaces/base/ftypes.h"
#include "QIPAddress.h"

using namespace VSTGUI;
using namespace Steinberg;

#define DEFAULT_IP "127.0.0.1"


class CIPControl : public CTextEdit, IControlListener
{
public:
	CIPControl (const CRect& size, int32_t tag, UTF8StringPtr txt = 0, CBitmap* background = 0, const int32_t style = 0);
	CIPControl (const CTextEdit& textEdit);
	virtual void valueChanged();
	virtual ~CIPControl() {};
protected:
	void valueChanged(CControl* pControl) { valueChanged(); }
	ShadowTec::CQIPAddress ipaddr;
};


class CIPControlCreator : public IViewCreator
{
public:
	// register this class with the view factory
	CIPControlCreator() { UIViewFactory::registerViewCreator(*this); }
	// return an unique name here
	IdStringPtr getViewName() const { return "CIPControl"; }
	// return the name here from where your custom view inherites.
	// Your view automatically supports the attributes from it.
	IdStringPtr getBaseViewName() const { return "CTextEdit"; }
	// create your view here.
	// Note you don't need to apply attributes here as the apply method will be called with this new view
	CView* create(const UIAttributes& attributes, const IUIDescription* description) const VSTGUI_OVERRIDE_VMETHOD;
	// apply custom attributes to your view
	bool apply(CView* view, const UIAttributes& attributes, const IUIDescription* description) const;
	// add your custom attributes to the list
	bool getAttributeNames(std::list<std::string>& attributeNames) const
	{
		attributeNames.push_back("my-custom-attribute");
		return true;
	}
	// return the type of your custom attributes
	AttrType getAttributeType(const std::string& attributeName) const
	{
		if (attributeName == "my-custom-attribute")
			return kIntegerType;
		return kUnknownType;
	}
	// return the string value of the custom attributes of the view
	bool getAttributeValue(CView* view, const std::string& attributeName, std::string& stringValue, const IUIDescription* desc) const;
};

